// -*-C++-*-
//
//  This file is part of SSim, a simple discrete-event simulator.
//  See http://www.inf.usi.ch/carzaniga/ssim/
//  
//  Copyright (C) 2004-2005 University of Colorado
//  
//  Authors: Antonio Carzaniga <firstname.lastname@usi.ch>
//           See AUTHORS for full details.
//  
//  SSim is free software: you can redistribute it and/or modify it under
//  the terms of the GNU General Public License as published by the Free
//  Software Foundation, either version 3 of the License, or (at your
//  option) any later version.
//  
//  SSim is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with SSim.  If not, see <http://www.gnu.org/licenses/>.
//
#include <string>
#include <iostream>

#include "../heap.h"

using namespace std;
using namespace ssim;

int main(int argc, char *argv[]) {
    heap<int> H;

    int i;
    while(cin >> i) {
	if (i < 0) {
	    if (H.empty()) {
		cout << "empty" << endl;
	    } else {
		cout << H.pop_first() << endl;
	    }
	} else {
	    H.insert(i);
	}
    }
    return 0;
}


